---
title: webhook
date: 2021-11-14T15:06:57Z
draft: false
---

# fun with webhooks
[webhook](https://github.com/adnanh/webhook) is a lightweight golang single binary to easily setup webhooks for your services

## Examples
### regenerate hugo
A webhook to regenerate my [hugo](https://gohugo.io) based website.
Using a webhook in my gitea project, content is updated upon each git push to my remote git project.
Details can be found in my [ansible-role-hugo](https://git.br0tkasten.de/br0tkasten/ansible-role-hugo)

/etc/webhooks.json
```
[
        {
                "id": "generate",
                "execute-command": "/sbin/genHugo",
                "command-working-directory": "/srv/hugo"
        }
]
```

/sbin/genHugo
```
#!/bin/sh

cd /srv/hugo
git pull
HUGO_ENV="production" hugo
```

